/**
 * Copyright (C) 2009 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.env.binding;

import org.jbpm.pvm.internal.jobexecutor.JobDbSession;
import org.jbpm.pvm.internal.jobexecutor.JobExecutorMessageSession;
import org.jbpm.pvm.internal.wire.binding.WireDescriptorBinding;
import org.jbpm.pvm.internal.wire.descriptor.ContextTypeRefDescriptor;
import org.jbpm.pvm.internal.wire.descriptor.ObjectDescriptor;
import org.jbpm.pvm.internal.wire.descriptor.TransactionRefDescriptor;
import org.jbpm.pvm.internal.xml.Parse;
import org.jbpm.pvm.internal.xml.Parser;
import org.w3c.dom.Element;


// FIXME: remove this class when MessageSessionBinding injects JobDbSession instead of DbSession.
public class BpelMessageSessionBinding extends WireDescriptorBinding {


  public BpelMessageSessionBinding() {
    super("bpel-message-session");
  }

  public Object parse(final Element element, final Parse parse, final Parser parser) {
    ObjectDescriptor objectDescriptor = new ObjectDescriptor();

    objectDescriptor.setClassName(JobExecutorMessageSession.class.getName());
    objectDescriptor.addInjection("transaction", new TransactionRefDescriptor());
    objectDescriptor.addInjection("dbSession", new ContextTypeRefDescriptor(JobDbSession.class));

    return objectDescriptor;
  }
}
