/**
 * Copyright (C) 2009 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.facade.def.full.impl;

import org.ow2.orchestra.facade.CopyUtil;
import org.ow2.orchestra.facade.def.full.ActivityFullDefinition;
import org.ow2.orchestra.facade.def.full.ActivityWithSingleChildFullDefinition;
import org.ow2.orchestra.facade.uuid.ActivityDefinitionUUID;
import org.ow2.orchestra.facade.uuid.ProcessDefinitionUUID;

public abstract class ActivityWithSingleChildFullDefinitionImpl extends ActivityFullDefinitionImpl implements
  ActivityWithSingleChildFullDefinition {

  private static final long serialVersionUID = 3923986677198695102L;

  protected ActivityFullDefinition enclosedActivity;

  protected ActivityWithSingleChildFullDefinitionImpl() {
  }

  public ActivityWithSingleChildFullDefinitionImpl(final ActivityDefinitionUUID uuid, final ProcessDefinitionUUID processUUID,
    final String name) {
    super(uuid, processUUID, name);
  }

  public ActivityWithSingleChildFullDefinitionImpl(final ActivityWithSingleChildFullDefinition activityFullDefinition) {
    super(activityFullDefinition);
    enclosedActivity = CopyUtil.fullCopy(activityFullDefinition.getEnclosedActivity());
  }

  public void setEnclosedActivity(final ActivityFullDefinition enclosedActivity) {
    this.enclosedActivity = enclosedActivity;
  }

  public ActivityFullDefinition getEnclosedActivity() {
    return this.enclosedActivity;
  }

  public ActivityDefinitionUUID getEnclosedActivityUUID() {
    return enclosedActivity.getUUID();
  }

}
