/**
 * Copyright (C) 2009 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.facade.def.full.impl;

import org.ow2.orchestra.facade.CopyUtil;
import org.ow2.orchestra.facade.def.ForDefinition;
import org.ow2.orchestra.facade.def.OnAlarmDefinition;
import org.ow2.orchestra.facade.def.UntilDefinition;
import org.ow2.orchestra.facade.def.full.ActivityFullDefinition;
import org.ow2.orchestra.facade.def.full.OnAlarmFullDefinition;
import org.ow2.orchestra.facade.def.impl.OnAlarmDefinitionImpl;
import org.ow2.orchestra.facade.uuid.ActivityDefinitionUUID;


public class OnAlarmFullDefinitionImpl implements OnAlarmFullDefinition {

  private UntilDefinition untilDefinition;
  private ForDefinition forDefinition;
  private ActivityDefinitionUUID activityDefinitionUUID;
  private ActivityFullDefinition activityFullDefinition;

  public OnAlarmFullDefinitionImpl(){
  }

  public OnAlarmFullDefinitionImpl(final OnAlarmFullDefinition onAlarmFullDefinition) {
    this.activityDefinitionUUID = onAlarmFullDefinition.getActivityDefinitionUUID();
    this.activityFullDefinition = CopyUtil.fullCopy(onAlarmFullDefinition.getActivityFullDefinition());
    this.forDefinition = CopyUtil.copy(onAlarmFullDefinition.getForDefinition());
    this.untilDefinition = CopyUtil.copy(onAlarmFullDefinition.getUntilDefinition());
  }

  public ActivityFullDefinition getActivityFullDefinition() {
    return activityFullDefinition;
  }

  public ActivityDefinitionUUID getActivityDefinitionUUID() {
    return activityDefinitionUUID;
  }

  public ForDefinition getForDefinition() {
    return forDefinition;
  }

  public UntilDefinition getUntilDefinition() {
    return untilDefinition;
  }

  public OnAlarmDefinition copy() {
    return new OnAlarmDefinitionImpl(this);
  }

  public OnAlarmFullDefinition fullCopy() {
    return new OnAlarmFullDefinitionImpl(this);
  }

  public void setActivityDefinitionUUID(final ActivityDefinitionUUID activityDefinitionUUID) {
    this.activityDefinitionUUID = activityDefinitionUUID;
  }

  public void setEnclosedActivityFullDefinition(final ActivityFullDefinition activityFullDefinition) {
    this.activityFullDefinition = activityFullDefinition;
  }

  public void setForDefinition(final ForDefinition forDefinition) {
    this.forDefinition = CopyUtil.copy(forDefinition);
  }

  public void setUntilDefinition(final UntilDefinition untilDefinition) {
    this.untilDefinition = CopyUtil.copy(untilDefinition);
  }

}
