/**
 * Copyright (C) 2009 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.facade.def.impl;

import org.ow2.orchestra.facade.CopyUtil;
import org.ow2.orchestra.facade.def.CompletionConditionDefinition;
import org.ow2.orchestra.facade.def.ForeachActivityDefinition;
import org.ow2.orchestra.facade.runtime.ActivityType;

public class ForeachActivityDefinitionImpl extends ActivityWithSingleChildDefinitionImpl implements ForeachActivityDefinition {

  private String finalCounterExpression;

  private String startCounterExpressionLanguage;

  private String startCounterExpression;

  private String finalCounterExpressionLanguage;

  private boolean parallelValue;

  private String counterName;

  private CompletionConditionDefinition completionConditionDefinition;

  public ForeachActivityDefinitionImpl(final ForeachActivityDefinition record) {
    super(record);
    this.counterName = record.getCounterName();
    this.parallelValue = record.isParallel();
    this.finalCounterExpression = record.getFinalCounterExpression();
    this.finalCounterExpressionLanguage = record.getFinalCounterExpressionLanguage();
    this.startCounterExpression = record.getStartCounterExpression();
    this.startCounterExpressionLanguage = record.getStartCounterExpressionLanguage();
    this.completionConditionDefinition = CopyUtil.copy(record.getCompletionConditionDefinition());
  }

  @Override
  public ActivityType getType() {
    return ActivityType.FOR_EACH;
  }

  public String getFinalCounterExpression() {
    return finalCounterExpression;
  }

  public String getFinalCounterExpressionLanguage() {
    return finalCounterExpressionLanguage;
  }

  public String getStartCounterExpression() {
    return startCounterExpression;
  }

  public String getStartCounterExpressionLanguage() {
    return startCounterExpressionLanguage;
  }

  public String getCounterName() {
    return counterName;
  }

  public boolean isParallel() {
    return parallelValue;
  }

  public CompletionConditionDefinition getCompletionConditionDefinition() {
    return completionConditionDefinition;
  }

}
