/**
 * Copyright (C) 2008 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.facade.runtime.full.impl;

import org.ow2.orchestra.facade.runtime.ActivityType;
import org.ow2.orchestra.facade.runtime.full.ProcessFullInstance;
import org.ow2.orchestra.facade.runtime.impl.ProcessInstanceImpl;
import org.ow2.orchestra.facade.uuid.ProcessDefinitionUUID;
import org.ow2.orchestra.facade.uuid.ProcessInstanceUUID;

/**
 *
 * @author Alfonso Fuca
 */
public class ProcessFullInstanceImpl extends ScopeActivityFullInstanceImpl implements ProcessFullInstance {

  private static final long serialVersionUID = -7228036760069352986L;

  protected ProcessFullInstanceImpl() {
  }

  public ProcessFullInstanceImpl(final ProcessInstanceUUID uuid, final ProcessDefinitionUUID processUUID) {
    super(uuid, processUUID, processUUID, uuid);
  }

  public ProcessFullInstanceImpl(final ProcessFullInstance record) {
    super(record);
  }

  @Override
  public ActivityType getType() {
    return ActivityType.PROCESS;
  }

  @Override
  public ProcessInstanceImpl copy() {
    return new ProcessInstanceImpl(this);
  }

  @Override
  public ProcessFullInstanceImpl fullCopy() {
    return new ProcessFullInstanceImpl(this);
  }

  @Override
  public ProcessInstanceUUID getUUID() {
    return instanceUUID;
  }
}
