/**
 * Copyright (C) 2007  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.facade.uuid;

import java.util.UUID;

import javax.xml.namespace.QName;

import org.ow2.orchestra.facade.runtime.ActivityType;


public abstract class IdFactory {

  private IdFactory() {

  }

  public static ProcessInstanceUUID getNewInstanceUUID(final ProcessDefinitionUUID processUUID, final long instanceNb) {
    ProcessInstanceUUID processInstanceUUID = new ProcessInstanceUUID(processUUID, instanceNb);
    return processInstanceUUID;
    //return new ProcessInstanceUUID(Misc.getUniqueId("testInstance-"));
  }

  public static ProcessDefinitionUUID getNewProcessUUID(final String targetNamespace, final String name) {
    QName qName = new QName(targetNamespace, name);
    ProcessDefinitionUUID processDefinitionUUID = new ProcessDefinitionUUID(qName, UUID.randomUUID().toString());
    return processDefinitionUUID;
    //return new ProcessDefinitionUUID(Misc.getUniqueId("testProcess-"));
  }

  public static ActivityInstanceUUID getNewActivityUUID(final ProcessInstanceUUID processInstanceUUID, final long activityCount) {
    ActivityInstanceUUID activityDefinitionUUID = new ActivityInstanceUUID(processInstanceUUID, activityCount, null);
    return activityDefinitionUUID;
    //return new ActivityInstanceUUID(Misc.getUniqueId("testActivity-"));
  }

  public static ActivityDefinitionUUID getNewActivityDefUUID(final ProcessDefinitionUUID processUUID, final int activityCount) {
    ActivityDefinitionUUID activityDefinitionUUID = new ActivityDefinitionUUID(processUUID, activityCount, ActivityType.UNKNOWN_ACTIVITY, null);
    return activityDefinitionUUID;
    //return new ActivityInstanceUUID(Misc.getUniqueId("testActivity-"));
  }
}
