/**
 * Copyright (C) 2009 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.parsing.binding;

import java.util.LinkedList;

import org.ow2.orchestra.facade.def.full.ActivityFullDefinition;
import org.ow2.orchestra.facade.def.full.ProcessFullDefinition;

/**
 *
 * @author Gael Lalire
 */
public class DefinitionKeeper {

  /**
   * Replace with Deque when java 5 will be deprecated.
   */
  private LinkedList<Object> parentList;

  private ProcessFullDefinition processFullDefinition;

  private int activityCount;

  private ActivityFullDefinition activityFullDefinition;

  public DefinitionKeeper() {
    parentList = new LinkedList<Object>();
    activityCount = 0;
  }

  public Object getParent() {
    if (parentList.isEmpty()) {
      return null;
    }
    return parentList.getFirst();
  }

  public void pushParent() {
    parentList.addFirst(activityFullDefinition);
  }

  public void pushParent(final Object parent) {
    parentList.addFirst(parent);
  }

  public void popParent() {
    Object first = parentList.removeFirst();
    if (first instanceof ActivityFullDefinition) {
      activityFullDefinition = (ActivityFullDefinition) first;
    }
  }

  public int getNextActivityCount() {
    activityCount++;
    return activityCount;
  }

  /**
   * @return the processFullDefinition
   */
  public ProcessFullDefinition getProcessFullDefinition() {
    return processFullDefinition;
  }

  /**
   * @return the activityFullDefinition
   */
  public ActivityFullDefinition getActivityFullDefinition() {
    return activityFullDefinition;
  }

  /**
   * @param activityFullDefinition the activityFullDefinition to set
   */
  public void setActivityFullDefinition(final ActivityFullDefinition activityFullDefinition) {
    this.activityFullDefinition = activityFullDefinition;
  }

  public void setProcessFullDefinition(final ProcessFullDefinition processFullDefinition) {
    this.processFullDefinition = processFullDefinition;
  }

}
