/**
 * Copyright (C) 2009 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.services;

import javax.xml.namespace.QName;

import org.jbpm.pvm.internal.job.MessageImpl;
import org.ow2.orchestra.runtime.BpelExecution;


public abstract class BpelMessageImpl<T> extends MessageImpl<T> {

  protected QName processQName;
  protected BpelExecution instance;
  private BpelExecution bpelExecution;

  protected void setBpelExecution(final BpelExecution bpelExecution) {
    this.bpelExecution = bpelExecution;
    bpelExecution.addBpelMessageJob(this);
  }


  protected BpelExecution getBpelExecution() {
    return bpelExecution;
  }
}
