/**
 * Copyright (C) 2008 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

/**
 * 
 */
package org.ow2.orchestra.services;

import java.util.HashMap;
import java.util.Map;

import org.jbpm.pvm.env.Environment;
import org.jbpm.pvm.internal.cmd.Command;
import org.ow2.orchestra.runtime.BpelExecution;
import org.ow2.orchestra.services.itf.Repository;

class SignalExecCommand implements Command<BpelExecution> {
  private final ExecElementToSignal execToSignal;

  public SignalExecCommand(final ExecElementToSignal execToSignal) {
    this.execToSignal = execToSignal;
  }

  public BpelExecution execute(final Environment environment) throws Exception {
    final Repository repository = environment.get(Repository.class);
    final BpelExecution exec = repository.getUpdatedExecution(this.execToSignal.getBpelExecution());
    if (exec != null) {
      final Map<String, Object> parameters = new HashMap<String, Object>();
      parameters.put("receivingElement",
          repository.getUpdatedReceivingElement(this.execToSignal.getReceivingElement()));
      exec.signal(parameters);
      return exec.getProcessInstance();
    } else {
      return this.execToSignal.getBpelExecution().getProcessInstance();
    }
  }
}